CF305 Mike and Feet 单调栈(求每个长度对应的最小数字)

来源:互联网 发布:c语言成绩管理系统6.0 编辑:程序博客网 时间:2024/06/16 06:11

题目链接:http://codeforces.com/contest/548/problem/D


D. Mike and Feet
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Mike is the president of country What-The-Fatherland. There are n bears living in this country besides Mike. All of them are standing in a line and they are numbered from 1 to n from left to right. i-th bear is exactly ai feet high.

A group of bears is a non-empty contiguous segment of the line. The size of a group is the number of bears in that group. The strengthof a group is the minimum height of the bear in that group.

Mike is a curious to know for each x such that 1 ≤ x ≤ n the maximum strength among all groups of size x.

Input

The first line of input contains integer n (1 ≤ n ≤ 2 × 105), the number of bears.

The second line contains n integers separated by space, a1, a2, ..., an (1 ≤ ai ≤ 109), heights of bears.

Output

Print n integers in one line. For each x from 1 to n, print the maximum strength among all groups of size x.

Sample test(s)
input
101 2 3 4 5 4 3 2 1 6
output
6 4 4 3 3 2 2 1 1 1 



单调栈:类似于poj2559的做法,将更新最大面积改为更新ans。(可参照http://blog.csdn.net/alongela/article/details/8230739)

#include<cstdio>#include<algorithm>#include<cstring>using namespace std;const int N = 200005;struct node{    int height,width;};node stack[N];//单调栈int ans[N],h[N];//ans记录结果,h输入序列int main(){int n,x;while(~scanf("%d",&n)&&n){        memset(ans,0,sizeof(ans));    for(int i=0;i<n;i++){            scanf("%d",&x);            h[i]=x;    }    h[n++]=0;//因为输入序列>0,所以后加0处理最后一个数就可以全部出栈        int top=0;        for(int i=0;i<n;i++){            int tmp=0; //需要累加的宽度            while(top>0&&stack[top-1].height>=h[i]){                 int ls=stack[top-1].width+tmp;                if(stack[top-1].height>ans[ls]) ans[ls]=stack[top-1].height;                tmp+=stack[top-1].width;                --top;//出栈            }            stack[top].height=h[i];            stack[top].width=tmp+1;            ++top;//进栈        }        for(int i=n-1;i>=1;i--) ans[i]=max(ans[i+1],ans[i]);        //单调栈只更新了值发生变化的点。所以在此处更新:未处理的点的值=(最近的宽度比它的点的值)                for(int i=1;i<n-1;i++) printf("%d ",ans[i]);        printf("%d\n",ans[n-1]);}return 0;}


0 0